#!/bin/ksh

if [ ! -d data ]; then
  echo "You are not in LPAR2RRD working directory"
  exit 0
fi
OUT=hcheck.txt
WWWDIR=`grep WEBDIR lpar2rrd.cfg|egrep -v "^#|export"|cut -d= -f2`

find data -exec ls -ld {} \; > $OUT
echo "===========" >> $OUT
ls -l >> $OUT
echo "===========" >> $OUT
find $WWWDIR  -exec ls -ld {} \; >> $OUT
echo "===========" >> $OUT
tail -1000 error.log >> $OUT
echo "===========" >> $OUT
cat load.out >> $OUT
echo "===========" >> $OUT
cat lpar2rrd.cfg >> $OUT
gzip -9 $OUT

